> ## Documentation Index
> Fetch the complete documentation index at: https://docs.useparagon.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Microsoft Dynamics Update Record Lead

**Provider API:** Microsoft Dataverse Web API (v9.0).


## OpenAPI

````yaml actionkit/openapi.json POST /projects/{project_id}/tools/#MICROSOFT_DYNAMICS_UPDATE_RECORD_LEAD
openapi: 3.0.0
info:
  title: ActionKit Tools API
  version: 1.0.0
servers:
  - url: https://actionkit.useparagon.com
    description: US Cloud
security: []
paths:
  /projects/{project_id}/tools/#MICROSOFT_DYNAMICS_UPDATE_RECORD_LEAD:
    post:
      summary: Microsoft Dynamics Update Record Lead
      parameters:
        - name: project_id
          in: path
          required: true
          schema:
            type: string
            description: >-
              Your Paragon Project ID. You can copy your Project ID from your
              dashboard URL or by clicking Copy Project ID under the Environment
              switcher.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                tool:
                  type: string
                  default: MICROSOFT_DYNAMICS_UPDATE_RECORD_LEAD
                parameters:
                  type: object
                  properties:
                    address1_addressid:
                      type: string
                      description: Unique identifier for address 1.
                    address1_addresstypecode:
                      type: number
                      description: Select the primary address type.
                    address1_city:
                      type: string
                      description: Type the city for the primary address.
                    address1_country:
                      type: string
                      description: Type the country or region for the primary address.
                    address1_county:
                      type: string
                      description: Type the county for the primary address.
                    address1_fax:
                      type: string
                      description: Type the fax number associated with the primary address.
                    address1_latitude:
                      type: number
                      description: >-
                        Type the latitude value for the primary address for use
                        in mapping and other applications.
                    address1_line1:
                      type: string
                      description: Type the first line of the primary address.
                    address1_line2:
                      type: string
                      description: Type the second line of the primary address.
                    address1_line3:
                      type: string
                      description: Type the third line of the primary address.
                    address1_longitude:
                      type: number
                      description: >-
                        Type the longitude value for the primary address for use
                        in mapping and other applications.
                    address1_name:
                      type: string
                      description: >-
                        Type a descriptive name for the primary address, such as
                        Corporate Headquarters.
                    address1_postalcode:
                      type: string
                      description: >-
                        Type the ZIP Code or postal code for the primary
                        address.
                    address1_postofficebox:
                      type: string
                      description: Type the post office box number of the primary address.
                    address1_shippingmethodcode:
                      type: number
                      description: >-
                        Select a shipping method for deliveries sent to this
                        address.
                    address1_stateorprovince:
                      type: string
                      description: Type the state or province of the primary address.
                    address1_telephone1:
                      type: string
                      description: >-
                        Type the main phone number associated with the primary
                        address.
                    address1_telephone2:
                      type: string
                      description: >-
                        Type a second phone number associated with the primary
                        address.
                    address1_telephone3:
                      type: string
                      description: >-
                        Type a third phone number associated with the primary
                        address.
                    address1_upszone:
                      type: string
                      description: >-
                        Type the UPS zone of the primary address to make sure
                        shipping charges are calculated correctly and deliveries
                        are made promptly, if shipped by UPS.
                    address1_utcoffset:
                      type: number
                      description: >-
                        Select the time zone, or UTC offset, for this address so
                        that other people can reference it when they contact
                        someone at this address.
                    address2_addressid:
                      type: string
                      description: Unique identifier for address 2.
                    address2_addresstypecode:
                      type: number
                      description: Select the secondary address type.
                    address2_city:
                      type: string
                      description: Type the city for the secondary address.
                    address2_country:
                      type: string
                      description: Type the country or region for the secondary address.
                    address2_county:
                      type: string
                      description: Type the county for the secondary address.
                    address2_fax:
                      type: string
                      description: >-
                        Type the fax number associated with the secondary
                        address.
                    address2_latitude:
                      type: number
                      description: >-
                        Type the latitude value for the secondary address for
                        use in mapping and other applications.
                    address2_line1:
                      type: string
                      description: Type the first line of the secondary address.
                    address2_line2:
                      type: string
                      description: Type the second line of the secondary address.
                    address2_line3:
                      type: string
                      description: Type the third line of the secondary address.
                    address2_longitude:
                      type: number
                      description: >-
                        Type the longitude value for the secondary address for
                        use in mapping and other applications.
                    address2_name:
                      type: string
                      description: >-
                        Type a descriptive name for the secondary address, such
                        as Corporate Headquarters.
                    address2_postalcode:
                      type: string
                      description: >-
                        Type the ZIP Code or postal code for the secondary
                        address.
                    address2_postofficebox:
                      type: string
                      description: >-
                        Type the post office box number of the secondary
                        address.
                    address2_shippingmethodcode:
                      type: number
                      description: >-
                        Select a shipping method for deliveries sent to this
                        address.
                    address2_stateorprovince:
                      type: string
                      description: Type the state or province of the secondary address.
                    address2_telephone1:
                      type: string
                      description: >-
                        Type the main phone number associated with the secondary
                        address.
                    address2_telephone2:
                      type: string
                      description: >-
                        Type a second phone number associated with the secondary
                        address.
                    address2_telephone3:
                      type: string
                      description: >-
                        Type a third phone number associated with the secondary
                        address.
                    address2_upszone:
                      type: string
                      description: >-
                        Type the UPS zone of the secondary address to make sure
                        shipping charges are calculated correctly and deliveries
                        are made promptly, if shipped by UPS.
                    address2_utcoffset:
                      type: number
                      description: >-
                        Select the time zone, or UTC offset, for this address so
                        that other people can reference it when they contact
                        someone at this address.
                    budgetamount:
                      type: number
                      description: >-
                        Information about the budget amount of the lead's
                        company or organization.
                    budgetstatus:
                      type: number
                      description: >-
                        Information about the budget status of the lead's
                        company or organization.
                    businesscard:
                      type: string
                      description: Stores Image of the Business Card
                    businesscardattributes:
                      type: string
                      description: Stores Business Card Control Properties.
                    campaignid:
                      type: object
                      description: >-
                        Choose the campaign that the lead was generated from to
                        track the effectiveness of marketing campaigns and
                        identify  communications received by the lead.
                      properties: {}
                    companyname:
                      type: string
                      description: >-
                        Type the name of the company associated with the lead.
                        This becomes the account name when the lead is qualified
                        and converted to a customer account.
                    confirminterest:
                      type: boolean
                      description: >-
                        Select whether the lead confirmed interest in your
                        offerings. This helps in determining the lead quality.
                    customerid:
                      type: object
                      description: >-
                        Select the customer account or contact to provide a
                        quick link to additional customer details, such as
                        account information, activities, and opportunities.
                      properties: {}
                    customeridtype:
                      type: object
                      description: CustomerIdType for lead
                      properties: {}
                    decisionmaker:
                      type: boolean
                      description: >-
                        Select whether your notes include information about who
                        makes the purchase decisions at the lead's company.
                    description:
                      type: string
                      description: >-
                        Type additional information to describe the lead, such
                        as an excerpt from the company's website.
                    donotbulkemail:
                      type: boolean
                      description: >-
                        Select whether the lead accepts bulk email sent through
                        marketing campaigns or quick campaigns. If Do Not Allow
                        is selected, the lead can be added to marketing lists,
                        but will be excluded from the email.
                    donotemail:
                      type: boolean
                      description: >-
                        Select whether the lead allows direct email sent from
                        Microsoft Dynamics 365.
                    donotfax:
                      type: boolean
                      description: Select whether the lead allows faxes.
                    donotphone:
                      type: boolean
                      description: Select whether the lead allows phone calls.
                    donotpostalmail:
                      type: boolean
                      description: Select whether the lead allows direct mail.
                    donotsendmm:
                      type: boolean
                      description: >-
                        Select whether the lead accepts marketing materials,
                        such as brochures or catalogs. Leads that opt out can be
                        excluded from marketing initiatives.
                    emailaddress1:
                      type: string
                      description: Type the primary email address for the lead.
                    emailaddress2:
                      type: string
                      description: Type the secondary email address for the lead.
                    emailaddress3:
                      type: string
                      description: Type a third email address for the lead.
                    entityimage:
                      type: object
                      description: Shows the default image for the record.
                      properties: {}
                    estimatedamount:
                      type: number
                      description: >-
                        Type the estimated revenue value that this lead will
                        generate to assist in sales forecasting and planning.
                    estimatedclosedate:
                      type: string
                      description: >-
                        Enter the expected close date for the lead, so that the
                        sales team can schedule timely follow-up meetings to
                        move the prospect to the next sales stage.
                    estimatedvalue:
                      type: number
                      description: >-
                        Type a numeric value of the lead's estimated value, such
                        as a product quantity, if no revenue amount can be
                        specified in the Est. Value field. This can be used for
                        sales forecasting and planning.
                    evaluatefit:
                      type: boolean
                      description: >-
                        Select whether the fit between the lead's requirements
                        and your offerings was evaluated.
                    fax:
                      type: string
                      description: >-
                        Type the fax number for the primary contact for the
                        lead.
                    firstname:
                      type: string
                      description: >-
                        Type the first name of the primary contact for the lead
                        to make sure the prospect is addressed correctly in
                        sales calls, email, and marketing campaigns.
                    followemail:
                      type: boolean
                      description: >-
                        Information about whether to allow following email
                        activity like opens, attachment views and link clicks
                        for emails sent to the lead.
                    industrycode:
                      type: number
                      description: >-
                        Select the primary industry in which the lead's business
                        is focused, for use in marketing segmentation and
                        demographic analysis.
                    initialcommunication:
                      type: number
                      description: >-
                        Choose whether someone from the sales team contacted
                        this lead earlier.
                    jobtitle:
                      type: string
                      description: >-
                        Type the job title of the primary contact for this lead
                        to make sure the prospect is addressed correctly in
                        sales calls, email, and marketing campaigns.
                    lastname:
                      type: string
                      description: >-
                        Type the last name of the primary contact for the lead
                        to make sure the prospect is addressed correctly in
                        sales calls, email, and marketing campaigns.
                    lastonholdtime:
                      type: string
                      description: >-
                        Contains the date and time stamp of the last on hold
                        time.
                    lastusedincampaign:
                      type: string
                      description: >-
                        Shows the date when the lead was last included in a
                        marketing campaign or quick campaign.
                    leadqualitycode:
                      type: number
                      description: >-
                        Select a rating value to indicate the lead's potential
                        to become a customer.
                    leadsourcecode:
                      type: number
                      description: >-
                        Select the primary marketing source that prompted the
                        lead to contact you.
                    middlename:
                      type: string
                      description: >-
                        Type the middle name or initial of the primary contact
                        for the lead to make sure the prospect is addressed
                        correctly.
                    mobilephone:
                      type: string
                      description: >-
                        Type the mobile phone number for the primary contact for
                        the lead.
                    msdyn_gdproptout:
                      type: boolean
                      description: Describes whether lead is opted out or not
                    msdyn_leadgrade:
                      type: number
                      description: msdyn_LeadGrade for lead
                    msdyn_leadkpiid:
                      type: object
                      description: LeadKPIId
                      properties: {}
                    msdyn_leadscore:
                      type: number
                      description: msdyn_LeadScore for lead
                    msdyn_leadscoretrend:
                      type: number
                      description: msdyn_LeadScoreTrend for lead
                    msdyn_ordertype:
                      type: number
                      description: >-
                        Whether the Opportunity created when qualifying this
                        Lead is for an Item- based or a Work-based sale
                    msdyn_predictivescoreid:
                      type: object
                      description: Predictive score
                      properties: {}
                    msdyn_salesassignmentresult:
                      type: number
                      description: (Deprecated)Result of the assignment rule process
                    msdyn_scorehistory:
                      type: string
                      description: msdyn_ScoreHistory for lead
                    msdyn_scorereasons:
                      type: string
                      description: msdyn_ScoreReasons for lead
                    msdyn_segmentid:
                      type: object
                      description: Unique identifier for Segment associated with Lead.
                      properties: {}
                    need:
                      type: number
                      description: >-
                        Choose how high the level of need is for the lead's
                        company.
                    numberofemployees:
                      type: number
                      description: >-
                        Type the number of employees that work at the company
                        associated with the lead, for use in marketing
                        segmentation and demographic analysis.
                    originatingcaseid:
                      type: object
                      description: >-
                        This attribute is used for Sample Service Business
                        Processes.
                      properties: {}
                    ownerid:
                      type: object
                      description: Owner Id
                      properties: {}
                    owneridtype:
                      type: object
                      description: Owner Id Type
                      properties: {}
                    pager:
                      type: string
                      description: >-
                        Type the pager number for the primary contact for the
                        lead.
                    parentaccountid:
                      type: object
                      description: >-
                        Choose an account to connect this lead to, so that the
                        relationship is visible in reports and analytics.
                      properties: {}
                    parentcontactid:
                      type: object
                      description: >-
                        Choose a contact to connect this lead to, so that the
                        relationship is visible in reports and analytics.
                      properties: {}
                    participatesinworkflow:
                      type: boolean
                      description: Shows whether the lead participates in workflow rules.
                    preferredcontactmethodcode:
                      type: number
                      description: Select the preferred method of contact.
                    prioritycode:
                      type: number
                      description: >-
                        Select the priority so that preferred customers or
                        critical issues are handled quickly.
                    processid:
                      type: string
                      description: >-
                        Contains the id of the process associated with the
                        entity.
                    purchaseprocess:
                      type: number
                      description: >-
                        Choose whether an individual or a committee will be
                        involved in the  purchase process for the lead.
                    purchasetimeframe:
                      type: number
                      description: >-
                        Choose how long the lead will likely take to make the
                        purchase, so the sales team will be aware.
                    qualificationcomments:
                      type: string
                      description: >-
                        Type comments about the qualification or scoring of the
                        lead.
                    qualifyingopportunityid:
                      type: object
                      description: >-
                        Choose the opportunity that the lead was qualified on
                        and then converted to.
                      properties: {}
                    revenue:
                      type: number
                      description: >-
                        Type the annual revenue of the company associated with
                        the lead to provide an understanding of the prospect's
                        business.
                    salesstage:
                      type: number
                      description: >-
                        Select the sales stage of this lead to aid the sales
                        team in their efforts to convert this lead to an
                        opportunity.
                    salesstagecode:
                      type: number
                      description: >-
                        Select the sales process stage for the lead to help
                        determine the probability of the lead converting to an
                        opportunity.
                    salutation:
                      type: string
                      description: >-
                        Type the salutation of the primary contact for this lead
                        to make sure the prospect is addressed correctly in
                        sales calls, email messages, and marketing campaigns.
                    schedulefollowup_prospect:
                      type: string
                      description: >-
                        Enter the date and time of the prospecting follow-up
                        meeting with the lead.
                    schedulefollowup_qualify:
                      type: string
                      description: >-
                        Enter the date and time of the qualifying follow-up
                        meeting with the lead.
                    sic:
                      type: string
                      description: >-
                        Type the Standard Industrial Classification (SIC) code
                        that indicates the lead's primary industry of business
                        for use in marketing segmentation and demographic
                        analysis.
                    slaid:
                      type: object
                      description: >-
                        Choose the service level agreement (SLA) that you want
                        to apply to the Lead record.
                      properties: {}
                    stageid:
                      type: string
                      description: >-
                        Contains the id of the stage where the entity is
                        located.
                    statecode:
                      type: number
                      description: >-
                        Shows whether the lead is open, qualified, or
                        disqualified. Qualified and disqualified leads are
                        read-only and can't be edited unless they are
                        reactivated.
                    statuscode:
                      type: number
                      description: Select the lead's status.
                    subject:
                      type: string
                      description: >-
                        Type a subject or descriptive name, such as the expected
                        order, company name, or marketing source list, to
                        identify the lead.
                    teamsfollowed:
                      type: number
                      description: Number of users or conversations followed the record
                    telephone1:
                      type: string
                      description: >-
                        Type the work phone number for the primary contact for
                        the lead.
                    telephone2:
                      type: string
                      description: >-
                        Type the home phone number for the primary contact for
                        the lead.
                    telephone3:
                      type: string
                      description: >-
                        Type an alternate phone number for the primary contact
                        for the lead.
                    timezoneruleversionnumber:
                      type: number
                      description: For internal use only.
                    transactioncurrencyid:
                      type: object
                      description: >-
                        Choose the local currency for the record to make sure
                        budgets are reported in the correct currency.
                      properties: {}
                    traversedpath:
                      type: string
                      description: >-
                        A comma separated list of string values representing the
                        unique identifiers of stages in a Business Process Flow
                        Instance in the order that they occur.
                    utcconversiontimezonecode:
                      type: number
                      description: >-
                        Time zone code that was in use when the record was
                        created.
                    websiteurl:
                      type: string
                      description: >-
                        Type the website URL for the company associated with
                        this lead.
                    yomicompanyname:
                      type: string
                      description: >-
                        Type the phonetic spelling of the lead's company name,
                        if the name is specified in Japanese, to make sure the
                        name is pronounced correctly in phone calls with the
                        prospect.
                    yomifirstname:
                      type: string
                      description: >-
                        Type the phonetic spelling of the lead's first name, if
                        the name is specified in Japanese, to make sure the name
                        is pronounced correctly in phone calls with the
                        prospect.
                    yomilastname:
                      type: string
                      description: >-
                        Type the phonetic spelling of the lead's last name, if
                        the name is specified in Japanese, to make sure the name
                        is pronounced correctly in phone calls with the
                        prospect.
                    yomimiddlename:
                      type: string
                      description: >-
                        Type the phonetic spelling of the lead's middle name, if
                        the name is specified in Japanese, to make sure the name
                        is pronounced correctly in phone calls with the
                        prospect.
                    entityId:
                      type: string
                      description: Entity ID to perform the operation on
                  required:
                    - lastname
                    - subject
                    - entityId
                  x-integration: microsoftDynamics
              required:
                - tool
                - parameters
      responses:
        '200':
          description: >-
            The Dataverse record after the update, as returned by Dataverse. The
            fields depend on the table and the connected environment. Fields
            with a null value are omitted from the example.
          content:
            application/json:
              examples:
                'Success: Updated':
                  summary: Lead updated
                  value:
                    '@odata.context': >-
                      https://example.crm.dynamics.com/api/data/v9.0/$metadata#leads/$entity
                    '@odata.etag': W/"36693522"
                    address1_shippingmethodcode: 1
                    _ownerid_value: 746951b2-9038-43b3-ac28-16366bf692e3
                    leadid: b8400eab-8944-42a4-a462-4b3d5341d0c9
                    fullname: Docs Example
                    merged: false
                    salesstagecode: 1
                    yomifullname: Docs Example
                    participatesinworkflow: false
                    evaluatefit: false
                    followemail: true
                    prioritycode: 1
                    _owninguser_value: 746951b2-9038-43b3-ac28-16366bf692e3
                    address2_shippingmethodcode: 1
                    leadqualitycode: 2
                    confirminterest: false
                    decisionmaker: false
                    msdyn_ordertype: 192350000
                    address1_addressid: 6eea129b-11f0-4009-a9c4-81a9a0825246
                    address1_addresstypecode: 1
                    donotphone: false
                    _createdby_value: 746951b2-9038-43b3-ac28-16366bf692e3
                    donotemail: false
                    donotsendmm: false
                    _modifiedby_value: 746951b2-9038-43b3-ac28-16366bf692e3
                    jobtitle: Engineer
                    companyname: Docs Example Co
                    donotpostalmail: false
                    _owningbusinessunit_value: a0b74d6c-90de-4c4f-a0e0-bf1888180f2d
                    modifiedon: '2026-10-16T06:20:58Z'
                    statuscode: 1
                    donotbulkemail: false
                    lastname: Docs Example
                    versionnumber: 36693522
                    statecode: 0
                    donotfax: false
                    msdyn_gdproptout: false
                    address2_addresstypecode: 1
                    createdon: '2026-10-16T06:19:42Z'
                    preferredcontactmethodcode: 1
                    address2_addressid: c71e4120-07f4-4175-ad29-a504536ad0e5
                    subject: Docs Example Lead
      security:
        - BearerAuth: []
components:
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >-
        Your [Paragon User
        Token](/getting-started/installing-the-connect-sdk#setup) (JWT), which
        you can generate using your project's signing keys.

````